<?php

/**
 * GWDK - Gadget Web Development Kit
 * 
 * Copyright (c) 2004-2005, Michael Wallner, IWORKS
 * All rights reserved.
 * 
 * @package     Gadget
 * @author      Michael Wallner <mike@iworks.at>
 * @version     $Revision: 1.3 $
 * 
 * @copyright   2004-2005 Michael Wallner, IWORKS
 * @license     http://dev.iworks.at/gadget/LICENSE.txt GWDK License
 * 
 * @cvs         $Id: Tagrules.php,v 1.3 2007-03-30 11:40:07 mike Exp $
 */

/**
 * Requires XML_Parser
 */
require_once 'XML/Parser.php';

/** 
 * Gadget_Formatter_Tagrules
 *
 * @package     Gadget
 * @since       1.0
 */
class Gadget_Formatter_Tagrules extends XML_Parser
{
    /**
     * Case Folding
     * 
     * @var bool
     */
    var $folding = true;
    
    /**
     * Tag Rules
     * 
     * @var array
     */
    var $rules = array();
    
    /**
     * Parse Rules
     * 
     * @access  public
     * @return  array
     * @param   string  $file
     */
    function parseRules($file)
    {
        if (!is_file($file)) {
            return array();
        }
        
        if (PEAR::isError($this->setInputFile($file))) {
            return array();
        }
        if (PEAR::isError($this->parse())) {
            return array();
        }
        
        return $this->rules;
    }
    
    /**
     * @ignore
     */
    function startHandler($xp, $e, $a)
    {
        if ($e === 'RULE') {
            $this->rules[$a['SEARCH']] = $a['REPLACE'];
        }
    }
}

?>
