<?php

/**
 * Gadget Web Development Kit
 * 
 * Copyright (c) 2004-2005, Michael Wallner, IWORKS
 * All rights reserved.
 * 
 * @package     Gadget
 * @subpackage  Gadget_Template
 * @author      Michael Wallner <mike@iworks.at>
 * @version     $Revision: 1.4 $
 * 
 * @copyright   2004-2005 Michael Wallner, IWORKS
 * @license     http://dev.iworks.at/gadget/LICENSE.txt GWDK License
 * 
 * @cvs         $Id: elseif.php,v 1.4 2007-03-30 11:40:08 mike Exp $
 */

/**
 * Requires Gadget_Template_Action
 */
require_once 'Gadget/Template/Action.php';

/** 
 * Gadget_Template_Action_elseif
 *
 * @package     Gadget
 * @subpackage  Gadget_Template
 * @since       1.0
 */
class Gadget_Template_Action_elseif extends Gadget_Template_Action
{
    /**
     * Name
     * 
     * @var string
     */
    var $name = 'elseif';
    
    /**
     * Recursive Pattern
     * 
     * @var string
     */
    var $recursivePattern = 'el(se)?if:?';
    
    /**
     * RAW Callback
     * 
     * @access  public
     * @return  string
     * @param   array   $args
     */
    function rawCallback($args)
    {
        return '} elseif ('. $this->parseArg($args[2]) .') {';
    }
    
}

?>
