<?php

/**
 * Gadget Web Development Kit
 * 
 * Copyright (c) 2004-2005, Michael Wallner, IWORKS
 * All rights reserved.
 * 
 * @package     Gadget
 * @subpackage  Gadget_Template
 * @author      Michael Wallner <mike@iworks.at>
 * @version     $Revision: 1.2 $
 * 
 * @copyright   2004-2005 Michael Wallner, IWORKS
 * @license     http://dev.iworks.at/gadget/LICENSE.txt GWDK License
 * 
 * @cvs         $Id: function.php,v 1.2 2007-03-30 11:40:08 mike Exp $
 */

/**
 * Requires Gadget_Template_Action
 */
require_once 'Gadget/Template/Action.php';

/** 
 * Gadget_Template_Action_function
 *
 * @package     Gadget
 * @subpackage  Gadget_Template
 * @since       1.1
 */
class Gadget_Template_Action_function extends Gadget_Template_Action
{
    /**
     * Name
     * 
     * @var string
     */
    var $name = 'function';
    
    /**
     * Recursive Pattern
     * 
     * @var string
     */
    var $recursivePattern = '(\w+)(?=\()';
    
    /**
     * RAW Callback
     * 
     * @access  public
     * @return  string
     * @param   array   $args
     */
    function rawCallback($args)
    {
        $call = $args[1] . $args[3];
        return function_exists($args[1]) ? $call : '$widget->'. $call;
    }
    
}

?>
