<?php

/**
 * Gadget Web Development Kit
 * 
 * Copyright (c) 2004-2005, Michael Wallner, IWORKS
 * All rights reserved.
 * 
 * @package     Gadget
 * @subpackage  Gadget_Template
 * @author      Michael Wallner <mike@iworks.at>
 * @version     $Revision: 1.4 $
 * 
 * @copyright   2004-2005 Michael Wallner, IWORKS
 * @license     http://dev.iworks.at/gadget/LICENSE.txt GWDK License
 * 
 * @cvs         $Id: gettext.php,v 1.4 2007-03-30 11:40:08 mike Exp $
 */

/**
 * Requires Gadget_Template_Action
 */
require_once 'Gadget/Template/Action.php';

/** 
 * Gadget_Template_Action_gettext
 *
 * @package     Gadget
 * @subpackage  Gadget_Template
 * @since       1.0
 */
class Gadget_Template_Action_gettext extends Gadget_Template_Action
{
    /**
     * Name
     * 
     * @var string
     */
    var $name = 'gettext';
    
    /**
     * On After Construct
     * 
     * @access  protected
     * @return  void
     */
    function onAfterConstruct()
    {
        $this->composedPattern = 
            $this->pcreDelimiter        .
            $this->quotedChars['start'] .
            '(_)(\(\'.*?(?<!\\\\)\'\))' .
            $this->quotedChars['end']   .
            $this->pcreDelimiter        .
            's'
        ;
    }
    
    /**
     * PHP Callback
     * 
     * @access  public
     * @return  string
     * @param   array   $args
     */
    function phpCallback($args)
    {
        return '<?php echo _'. $args[2] .'; ?>';
    }
    
    /**
     * RAW Callback
     * 
     * @access  public
     * @return  string
     * @param   array
     */
    function rawCallback($args)
    {
        return '_'. $args[2];
    }
    
}

?>
