<?php

/**
 * GWDK - Gadget Web Development Kit
 * 
 * Copyright (c) 2004-2005, Michael Wallner, IWORKS
 * All rights reserved.
 * 
 * @package     Gadget
 * @subpackage  Gadget_Template
 * @author      Michael Wallner <mike@iworks.at>
 * @version     $Revision: 1.4 $
 * 
 * @copyright   2004-2005 Michael Wallner, IWORKS
 * @license     http://dev.iworks.at/gadget/LICENSE.txt GWDK License
 * 
 * @cvs         $Id: Plugin.php,v 1.4 2007-03-30 11:40:08 mike Exp $
 */

/**
 * Gadget_Template Constant for Gadget_Plugin
 */
define('GADGET_TEMPLATE', 'template');

/**
 * Requires Gadget_Plugin
 */
require_once 'Gadget/Plugin.php';

/**
 * Gadget_Template_Plugin configurations
 * @ignore
 */
$GLOBALS['_Gadget'][GADGET_TEMPLATE]['Config'] = array();

/**
 * Gadget_Template_Plugin registry
 * @ignore
 */
$GLOBALS['_Gadget'][GADGET_TEMPLATE]['Registry'] = array(
    'gettext'   => array(
        'default'   => array('Gadget_Template_Plugin_gettext', null),
        'userdef'   => array()
    ),
    'nl2sp'     => array(
        'default'   => array('Gadget_Template_Plugin_nl2sp', null),
        'userdef'   => array()
    ),
    'normalize' => array(
        'default'   => array('Gadget_Template_Plugin_normalize', null),
        'userdef'   => array()
    ),
);

/**
 * Gadget_Template_Plugin
 *
 * @package     Gadget
 * @subpackage  Gadget_Template
 * @since       1.0
 */
class Gadget_Template_Plugin extends Gadget_Plugin
{
    /**
     * Plugin
     * 
     * @var string
     */
    var $plugin = GADGET_TEMPLATE;
    
    /**
     * Run
     * 
     * @static
     * @access  public
     * @return  string
     * @param   string  $plugin
     * @param   object  Gadget_Template_Compiler $Compiler
     * @param   string  $data
     * @param   array   $attr
     */
    function run($plugin, &$Compiler, $data, $attr)
    {
        if ($action = &parent::singleton(GADGET_TEMPLATE, $plugin)) {
            return $action->execute($data, $attr, $Compiler);
        }
        return $data;
    }
}

?>
