<?php

/**
 * GWDK - Gadget Web Development Kit
 * 
 * Copyright (c) 2004-2005, Michael Wallner, IWORKS
 * All rights reserved.
 * 
 * @package     Gadget
 * @subpackage  Gadget_Template
 * @author      Michael Wallner <mike@iworks.at>
 * @version     $Revision: 1.4 $
 * 
 * @copyright   2004-2005 Michael Wallner, IWORKS
 * @license     http://dev.iworks.at/gadget/LICENSE.txt GWDK License
 * 
 * @cvs         $Id: gettext.php,v 1.4 2007-03-30 11:40:08 mike Exp $
 */

/**
 * Requires Gadget_Template_Plugin
 */
require_once 'Gadget/Template/Plugin.php';

/**
 * Gadget_Template_Plugin_gettext
 *
 * @package     Gadget
 * @subpackage  Gadget_Template
 * @since       1.0
 */
class Gadget_Template_Plugin_gettext extends Gadget_Template_Plugin
{
    /**
     * Execute
     * 
     * @access  protected
     * @return  string
     * @param   string  $data
     * @param   array   $attr
     */
    function execute($data, $attr, &$Compiler)
    {
        return $Compiler->phpize('gettext', 
            '(\''. addcslashes($data, '\'') .'\')');
    }
}

?>
