<?php

/**
 * GWDK - Gadget Web Development Kit
 * 
 * Copyright (c) 2004-2005, Michael Wallner, IWORKS
 * All rights reserved.
 * 
 * @package     Gadget
 * @subpackage  Gadget_Tree
 * @author      Michael Wallner <mike@iworks.at>
 * @version     $Revision: 1.2 $
 * 
 * @copyright   2004-2005 Michael Wallner, IWORKS
 * @license     http://dev.iworks.at/gadget/LICENSE.txt GWDK License
 * 
 * @cvs         $Id: NodeTest.php,v 1.2 2005-04-21 15:17:38 mike Exp $
 */

/** 
 * Gadget_Tree_Search_NodeTest
 *
 * @package     Gadget
 * @subpackage  Gadget_Tree
 * @since       1.0
 */
class Gadget_Tree_Search_NodeTest
{
    /**
     * Type
     * 
     * @var string
     */
    var $type;
    
    /**
     * Operator
     * 
     * @var string
     */
    var $operator;
    
    /**
     * Left Operand
     * 
     * @var string
     */
    var $L;
    
    /**
     * Right Operand
     * 
     * @var string
     */
    var $R;
    
    /**
     * Constructor
     * 
     * @param   string  $type
     * @param   array   $test
     */
    function Gadget_Tree_Search_NodeTest($type, $test)
    {
        $this->type = strToLower($type);
        $this->operator = $test[1];
        
        #print_r($test);
        
        switch ($this->type)
        {
            case 'attribute':
                $this->L = substr($test[0], 1);
                $this->R = $test[2];
            break;
            
            case 'function':
                $this->L = $test[0];
                $this->R = $test[2];
            break;
            
            default:
                Gadget_Tree::raiseError("Not a valid NodeTest type: $type");
            break;
        }
    }
    
    /**
     * Test Node
     * 
     * @access  public
     * @return  bool
     * @param   object  Gadget_Tree_Node $node
     */
    function testNode(&$node)
    {
        #echo "Testing {$this->type} {$this->L} on/of {$node->name} to be {$this->R} ";
        switch ($this->type)
        {
            case 'attribute':
                #echo $node->getMeta($this->L), "\n";
                return Gadget_Tree_Search::compare($this->operator,
                    $node->getMeta($this->L), trim($this->R, '"'));
            break;
            
            case 'function':
                switch ($this->L)
                {
                    case 'position()':
                        #echo $node->position(), "\n";
                        return Gadget_Tree_Search::compare($this->operator,
                            $node->position(), $this->R);
                    break;
                }
            break;
        }
        return false;
    }
}

?>
