<?php

/**
 * GWDK - Gadget Web Development Kit
 * 
 * Copyright (c) 2004-2005, Michael Wallner, IWORKS
 * All rights reserved.
 * 
 * @package     Gadget
 * @subpackage  Gadget_Widget
 * @author      Michael Wallner <mike@iworks.at>
 * @version     $Revision: 1.7 $
 * 
 * @copyright   2004-2005 Michael Wallner, IWORKS
 * @license     http://dev.iworks.at/gadget/LICENSE.txt GWDK License
 * 
 * @cvs         $Id: LoginBox.php,v 1.7 2007-03-30 11:40:09 mike Exp $
 */

/**
 * Requires Gadget_Widget
 */
require_once 'Gadget/Widget.php';

/**
 * LoginBox
 *
 * @package     Gadget
 * @subpackage  Gadget_Widget
 * @since       1.0
 */
class LoginBox extends Gadget_Widget
{
    var $template = 'LoginBox.html';
    var $authService;
    
    function main()
    {
        $this->form('LoginBoxForm');
        $this->qform->addElement('text',       'loginUser',    _('Dein Nickname'));
        $this->qform->addElement('password',   'loginPass',    _('Dein Passwort'));
        $this->qform->addElement('submit',     'loginSubmit',  _('OK'));
        
        $this->qform->applyFilter('__ALL__', 'trim');
        $this->qform->addRule('loginUser', _('Bitte Nickname angeben!'), 'required');
        $this->qform->addRule('loginPass', _('Bitte Passwort angeben!'), 'required');
        $this->qform->addRule('loginUser', _('Bitte Nickname angeben!'), 'required', null, 'client');
        $this->qform->addRule('loginPass', _('Bitte Passwort angeben!'), 'required', null, 'client');
        
        if ($this->qform->validate()) {
            $this->qform->process(array(&$this, 'processForm'), false);
        }
    }
    
    function processForm($values)
    {
        extract($values);
        $this->authService = &Gadget::service(SERVICE_AUTH);
        $this->show = !$this->authService->run($loginUser, $loginPass);
    }
}

?>